Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCollision.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCollision.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCollision.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4QCollision.cc,v 1.28 2008/10/02 21:10:07 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QCollision.cc,v 1.32 2009/04/17 15:22:31 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCollision class -----------------
@@ -34,7 +34,10 @@
 // ********** This CLASS is temporary moved from the photolepton_hadron directory *********
 // ****************************************************************************************
-
+// Short description: This is a universal class for the incoherent (inelastic)
+// nuclear interactions in the CHIPS model.
+// ---------------------------------------------------------------------------
 //#define debug
 //#define pdebug
+//#define ldebug
 //#define ppdebug
 //#define qedebug
@@ -250,5 +253,5 @@
     G4cout<<"G4QCollision::GetMeanFreePath: isovectorLength="<<isoSize<<G4endl; // Result
 #endif
-    if(isoSize)                             // The Element has non-trivial abumdance set
+    if(isoSize)                             // The Element has non-trivial abundance set
     {
       indEl=pElement->GetIndex()+1;         // Index of the non-trivial element
@@ -262,12 +265,12 @@
           G4int N=pElement->GetIsotope(j)->GetN()-Z; // N means A=N+Z !
           if(pElement->GetIsotope(j)->GetZ()!=Z)G4cerr<<"G4QCollision::GetMeanFreePath"
-																																	<<": Z="<<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
+                                 <<": Z="<<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
           G4double abund=abuVector[j];
-								  std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
+          std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
 #ifdef debug
           G4cout<<"G4QCollision::GetMeanFreePath: p#="<<j<<",N="<<N<<",ab="<<abund<<G4endl;
 #endif
           newAbund->push_back(pr);
-						  }
+        }
 #ifdef debug
         G4cout<<"G4QCollision::GetMeanFreePath: pairVectLength="<<newAbund->size()<<G4endl;
@@ -384,4 +387,5 @@
   static const G4double mPi0s= mPi0*mPi0;
   static const G4double mDeut= G4QPDGCode(2112).GetNuclMass(1,1,0);// Mass of deuteron
+  //static const G4double mDeut2=mDeut*mDeut;                      // SquaredMassOfDeuteron
   static const G4double mTrit= G4QPDGCode(2112).GetNuclMass(1,2,0);// Mass of tritium
   static const G4double mHel3= G4QPDGCode(2112).GetNuclMass(2,1,0);// Mass of Helium3
@@ -432,5 +436,5 @@
   static G4bool CWinit = true;              // CHIPS Warld needs to be initted
   if(CWinit)
-		{
+  {
     CWinit=false;
     G4QCHIPSWorld::Get()->GetParticles(nPartCWorld); // Create CHIPS World (234 part.max)
@@ -457,5 +461,5 @@
 #ifdef debug
   G4double mp=proj4M.m();
-  G4cout<<"G4QCollis::PostStepDoIt:called, P="<<Momentum<<"="<<momentum<<",m="<<mp<<G4endl;
+  G4cout<<"-->G4QCollis::PostStDoIt:called,P="<<Momentum<<"="<<momentum<<",m="<<mp<<G4endl;
 #endif
   if (!IsApplicable(*particle))  // Check applicability
@@ -507,5 +511,5 @@
 #ifdef debug
   G4int prPDG=particle->GetPDGEncoding();
-		G4cout<<"G4QCollision::PostStepDoIt: projPDG="<<projPDG<<", stPDG="<<prPDG<<G4endl;
+  G4cout<<"G4QCollision::PostStepDoIt: projPDG="<<projPDG<<", stPDG="<<prPDG<<G4endl;
 #endif
   if(!projPDG)
@@ -516,5 +520,5 @@
   G4int EPIM=ElProbInMat.size();
 #ifdef debug
-		G4cout<<"G4QCollis::PostStDoIt: m="<<EPIM<<",n="<<nE<<",T="<<ElProbInMat[EPIM-1]<<G4endl;
+  G4cout<<"G4QCollis::PostStDoIt: m="<<EPIM<<",n="<<nE<<",T="<<ElProbInMat[EPIM-1]<<G4endl;
 #endif
   G4int i=0;
@@ -523,7 +527,7 @@
     G4double rnd = ElProbInMat[EPIM-1]*G4UniformRand();
     for(i=0; i<nE; ++i)
-		  {
-#ifdef debug
-				  G4cout<<"G4QCollision::PostStepDoIt:E["<<i<<"]="<<ElProbInMat[i]<<",r="<<rnd<<G4endl;
+    {
+#ifdef debug
+      G4cout<<"G4QCollision::PostStepDoIt:E["<<i<<"]="<<ElProbInMat[i]<<",r="<<rnd<<G4endl;
 #endif
       if (rnd<ElProbInMat[i]) break;
@@ -534,5 +538,5 @@
   Z=static_cast<G4int>(pElement->GetZ());
 #ifdef debug
-				G4cout<<"G4QCollision::PostStepDoIt: i="<<i<<", Z(element)="<<Z<<G4endl;
+    G4cout<<"G4QCollision::PostStepDoIt: i="<<i<<", Z(element)="<<Z<<G4endl;
 #endif
   if(Z<=0)
@@ -545,5 +549,5 @@
   G4int nofIsot=SPI->size();               // #of isotopes in the element i
 #ifdef debug
-		G4cout<<"G4QCollis::PosStDoIt:n="<<nofIsot<<",T="<<(*SPI)[nofIsot-1]<<G4endl;
+  G4cout<<"G4QCollis::PosStDoIt:n="<<nofIsot<<",T="<<(*SPI)[nofIsot-1]<<G4endl;
 #endif
   G4int j=0;
@@ -554,5 +558,5 @@
     {
 #ifdef debug
-				  G4cout<<"G4QCollision::PostStepDoIt: SP["<<j<<"]="<<(*SPI)[j]<<", r="<<rndI<<G4endl;
+      G4cout<<"G4QCollision::PostStepDoIt: SP["<<j<<"]="<<(*SPI)[j]<<", r="<<rndI<<G4endl;
 #endif
       if(rndI < (*SPI)[j]) break;
@@ -562,5 +566,5 @@
   G4int N =(*IsN)[j]; ;                    // Randomized number of neutrons
 #ifdef debug
-		G4cout<<"G4QCollision::PostStepDoIt: j="<<i<<", N(isotope)="<<N<<G4endl;
+  G4cout<<"G4QCollision::PostStepDoIt: Z="<<Z<<", j="<<i<<", N(isotope)="<<N<<G4endl;
 #endif
   if(N<0)
@@ -576,5 +580,5 @@
   if(dsr<dd)dsr=dd;
   if(manualFlag) G4QNucleus::SetParameters(freeNuc,freeDib,clustProb,mediRatio); // ManualP
-		else if(projPDG==-2212) G4QNucleus::SetParameters(1.-dsr-dsr,dd+dd,5.,10.);//aP ClustPars
+  else if(projPDG==-2212) G4QNucleus::SetParameters(1.-dsr-dsr,dd+dd,5.,10.);//aP ClustPars
   else if(projPDG==-211)  G4QNucleus::SetParameters(.67-dsr,.32-dsr,5.,9.);//Pi- ClustPars
 #ifdef debug
@@ -607,6 +611,6 @@
   // Lepto-nuclear case with the equivalent photon algorithm. @@InFuture + NC (?)
   //
-  if (aProjPDG == 11 || aProjPDG == 13 || aProjPDG == 15) {
-
+  if (aProjPDG == 11 || aProjPDG == 13 || aProjPDG == 15)
+  {
 #ifdef debug
     G4cout<<"G4QCollision::PostStDoIt:startSt="<<aParticleChange.GetTrackStatus()<<G4endl;
@@ -646,5 +650,5 @@
     G4double photonEnergy = CSmanager->GetExchangeEnergy(); // Energy of EqivExchangePart
 #ifdef debug
-				G4cout<<"G4QCol::PStDoIt: kE="<<kinEnergy<<",dir="<<dir<<",phE="<<photonEnergy<<G4endl;
+    G4cout<<"G4QCol::PStDoIt: kE="<<kinEnergy<<",dir="<<dir<<",phE="<<photonEnergy<<G4endl;
 #endif
     if( kinEnergy < photonEnergy || photonEnergy < 0.)
@@ -708,5 +712,5 @@
     G4double cost=(iniE*finE-ml2-photonQ2/2)/iniP/finP; // cos(scat_ang_of_lepton)
 #ifdef pdebug
-		  G4cout<<"G4QC::PSDoIt:Q2="<<photonQ2<<",ct="<<cost<<",Pi="<<iniP<<",Pf="<<finP<<G4endl;
+    G4cout<<"G4QC::PSDoIt:Q2="<<photonQ2<<",ct="<<cost<<",Pi="<<iniP<<",Pf="<<finP<<G4endl;
 #endif
     if(cost>1.) cost=1.;                 // To avoid the accuracy of calculation problem
@@ -717,5 +721,5 @@
     G4double absEn = std::pow(am,third)*GeV;  // @@(b) Mean Energy Absorbed by a Nucleus
     //if(am>1 && absEn < photonEnergy)     // --> the absorption of energy can happen
-				if(absEn < photonEnergy)     // --> the absorption of energy can happen
+    if(absEn < photonEnergy)     // --> the absorption of energy can happen
     {
       G4double abtEn = absEn+hdM;        // @@(b) MeanEnergyAbsorbed by a nucleus (+M_N)
@@ -727,13 +731,13 @@
       absMom         = std::sqrt(abMo2); // Absorbed Momentum
       if(absMom < phMo)                  // --> the absorption of momentum can happen
-				  {
+      {
         G4double dEn = photonEnergy - absEn; // Leading energy
         G4double dMo = phMo - absMom;    // Leading momentum
         G4double sF  = dEn*dEn - dMo*dMo;// s of leading particle
 #ifdef ppdebug
-				    G4cout<<"-PhotoAbsorption-G4QCol::PStDoIt:sF="<<sF<<",phEn="<<photonEnergy<<G4endl;
+        G4cout<<"-PhotoAbsorption-G4QCol::PStDoIt:sF="<<sF<<",phEn="<<photonEnergy<<G4endl;
 #endif
         if(sF > stmPi)                   // --> Leading fragmentation is possible
-								{
+        {
           photonEnergy = absEn;          // New value of the photon energy
           photonQ2=abMo2-absEn*absEn;    // New value of the photon Q2
@@ -757,5 +761,5 @@
     aParticleChange.ProposeMomentumDirection(findir); // new direction for the lepton
 #ifdef pdebug
-		  G4cout<<"G4QCollision::PostStepDoIt: E="<<aParticleChange.GetEnergy()<<"="<<finE<<"-"
+    G4cout<<"G4QCollision::PostStepDoIt: E="<<aParticleChange.GetEnergy()<<"="<<finE<<"-"
           <<ml<<", d="<<*aParticleChange.GetMomentumDirection()<<","<<findir<<G4endl;
 #endif
@@ -765,5 +769,5 @@
       G4double ptm=photon3M.mag();                    // 3M of the virtual photon
 #ifdef ppdebug
-		    G4cout<<"-Absorption-G4QCollision::PostStepDoIt: ph3M="<<photon3M<<", eIn3M="
+      G4cout<<"-Absorption-G4QCollision::PostStepDoIt: ph3M="<<photon3M<<", eIn3M="
             <<iniP*dir<<", eFin3M="<<finP*findir<<", abs3M="<<absMom<<"<ptm="<<ptm<<G4endl;
 #endif
@@ -772,16 +776,16 @@
       proj4M=G4LorentzVector(lead3M,absEn); // 4-momentum of leading System
 #ifdef ppdebug
-		    G4cout<<"-->G4QC::PoStDoIt: new sF="<<proj4M.m2()<<", lead4M="<<proj4M<<G4endl;
+      G4cout<<"-->G4QC::PoStDoIt: new sF="<<proj4M.m2()<<", lead4M="<<proj4M<<G4endl;
 #endif
       lead4M=proj4M;                        // Remember 4-mom for the total 4-momentum
       G4Quasmon* pan= new G4Quasmon(G4QContent(1,1,0,1,1,0),proj4M);// ---> DELETED -->---+
       try                                                           //                    |
-	     {                                                             //                    |
-	       delete leadhs;                                              //                    |
+      {                                                             //                    |
+        delete leadhs;                                              //                    |
         G4QNucleus vac(90000000);                                   //                    |
         leadhs=pan->Fragment(vac,1);  // DELETED after it is copied to output vector      |
       }                                                             //                    |
       catch (G4QException& error)                                   //                    |
-	     {                                                             //                    |
+      {                                                             //                    |
         G4cerr<<"***G4QCollision::PostStepDoIt: G4Quasmon Exception is catched"<<G4endl;//|
         G4Exception("G4QCollision::PostStepDoIt:","72",FatalException,"QuasmonCrash");  //|
@@ -789,5 +793,5 @@
       delete pan;                              // Delete the Nuclear Environment <----<---+
 #ifdef ppdebug
-						G4cout<<"G4QCol::PStDoIt: l4M="<<proj4M<<proj4M.m2()<<", N="<<leadhs->size()<<",pt="
+      G4cout<<"G4QCol::PStDoIt: l4M="<<proj4M<<proj4M.m2()<<", N="<<leadhs->size()<<",pt="
             <<ptm<<",pa="<<absMom<<",El="<<absEn<<",Pl="<<ptm-absMom<<G4endl;
 #endif
@@ -796,5 +800,5 @@
     proj4M=G4LorentzVector(photon3M,photonEnergy);
 #ifdef debug
-		  G4cout<<"G4QCollision::PostStDoIt: St="<<aParticleChange.GetTrackStatus()<<", g4m="
+    G4cout<<"G4QCollision::PostStDoIt: St="<<aParticleChange.GetTrackStatus()<<", g4m="
           <<proj4M<<", lE="<<finE<<", lP="<<finP*findir<<", d="<<findir.mag2()<<G4endl;
 #endif
@@ -803,40 +807,41 @@
   // neutrinoNuclear interactions (nu_e, nu_mu only)
   //
-  } else if (aProjPDG == 12 || aProjPDG == 14) {
-
+  }
+  else if (aProjPDG == 12 || aProjPDG == 14)
+  {
     G4double kinEnergy= projHadron->GetKineticEnergy()/MeV; // Total energy of the neutrino
     G4double dKinE=kinEnergy+kinEnergy;  // doubled energy for s calculation
 #ifdef debug
-		  G4cout<<"G4QCollision::PostStDoIt: 2*nuEnergy="<<dKinE<<"(MeV), PDG="<<projPDG<<G4endl;
+    G4cout<<"G4QCollision::PostStDoIt: 2*nuEnergy="<<dKinE<<"(MeV), PDG="<<projPDG<<G4endl;
 #endif
     G4ParticleMomentum dir = projHadron->GetMomentumDirection(); // unit vector
     G4double ml  = mu;
-    G4double ml2 =	mu2;
-    //G4double mlN =	muN;
-    G4double mlN2=	muN2;
-    G4double fmlN=	fmuN;
-    G4double mlsN=	musN;
-    //G4double mlP =	muP;
-    G4double mlP2=	muP2;
-    G4double fmlP=	fmuP;
-    G4double mlsP=	musP;
-    G4double mldM=	mudM;
-    //G4double mlD =	muD;
-    G4double mlD2=	muD2;
+    G4double ml2 = mu2;
+    //G4double mlN = muN;
+    G4double mlN2= muN2;
+    G4double fmlN= fmuN;
+    G4double mlsN= musN;
+    //G4double mlP = muP;
+    G4double mlP2= muP2;
+    G4double fmlP= fmuP;
+    G4double mlsP= musP;
+    G4double mldM= mudM;
+    //G4double mlD = muD;
+    G4double mlD2= muD2;
     if(aProjPDG==12)
     {
       ml  = me;
-      ml2 =	me2;
-      //mlN =	meN;
-      mlN2=	meN2;
-      fmlN=	fmeN;
-      mlsN=	mesN;
-      //mlP =	meP;
-      mlP2=	meP2;
-      fmlP=	fmeP;
-      mlsP=	mesP;
-      mldM=	medM;
-      //mlD =	meD;
-      mlD2=	meD2;
+      ml2 = me2;
+      //mlN = meN;
+      mlN2= meN2;
+      fmlN= fmeN;
+      mlsN= mesN;
+      //mlP = meP;
+      mlP2= meP2;
+      fmlP= fmeP;
+      mlsP= mesP;
+      mldM= medM;
+      //mlD = meD;
+      mlD2= meD2;
     }
     G4VQCrossSection* CSmanager =G4QNuMuNuclearCrossSection::GetPointer(); // (nu,l)
@@ -881,5 +886,5 @@
     G4bool secnu=false;
     if(xSec*G4UniformRand()>xSec1)               // recover neutrino/antineutrino
-				{
+    {
       if(scatPDG>0) scatPDG++;
       else          scatPDG--;
@@ -900,5 +905,5 @@
       totCS1 = qelCS1;
       totCS2 = qelCS2;
-				}
+    }
     // make different definitions for neutrino and antineutrino
     G4double mIN=mProt;                          // Just a prototype (for anu, Z=1, N=0)
@@ -956,5 +961,5 @@
     {
       if(Z>1||N>0)                               // Calculate the splitted mass
-						{
+      {
         targPDG-=1000;                           // Anti-Neutrino -> subtract proton
         G4QPDGCode targQPDG(targPDG);
@@ -973,5 +978,5 @@
     G4double s=mIN*(mIN+dKinE);                  // s=(M_cm)^2=m2+2mE (m=targetMass,E=E_nu)
 #ifdef debug
-		  G4cout<<"G4QCollision::PostStDoIt: s="<<s<<" >? OT="<<OT<<", mlD2="<<mlD2<<G4endl;
+    G4cout<<"G4QCollision::PostStDoIt: s="<<s<<" >? OT="<<OT<<", mlD2="<<mlD2<<G4endl;
 #endif
     if(s<=OT)                                    // *** Do nothing solution ***
@@ -986,5 +991,5 @@
     }
 #ifdef debug
-  		G4cout<<"G4QCollision::PostStDoIt: Stop and kill the projectile neutrino"<<G4endl;
+    G4cout<<"G4QCollision::PostStDoIt: Stop and kill the projectile neutrino"<<G4endl;
 #endif
     aParticleChange.ProposeEnergy(0.);
@@ -998,5 +1003,5 @@
       else      Q2=CSmanager->GetQEL_ExchangeQ2();
 #ifdef debug
-  		  G4cout<<"G4QCollision::PostStDoIt:QuasiEl(nu="<<secnu<<"),s="<<s<<",Q2="<<Q2<<G4endl;
+      G4cout<<"G4QCollision::PostStDoIt:QuasiEl(nu="<<secnu<<"),s="<<s<<",Q2="<<Q2<<G4endl;
 #endif
       //G4double ds=s+s;                          // doubled s
@@ -1032,5 +1037,5 @@
       else      Q2=CSmanager2->GetNQE_ExchangeQ2();
 #ifdef debug
-  		  G4cout<<"G4QColl::PStDoIt: MultiPeriferal s="<<s<<",Q2="<<Q2<<",T="<<targPDG<<G4endl;
+      G4cout<<"G4QColl::PStDoIt: MultiPeriferal s="<<s<<",Q2="<<Q2<<",T="<<targPDG<<G4endl;
 #endif
       if(secnu) projPDG=CSmanager2->GetExchangePDGCode();// PDG Code of the effective gamma
@@ -1055,5 +1060,5 @@
       {
 #ifdef debug
-  		    G4cout<<"*G4QCollision::PostStDoIt: cost="<<cost<<", Q2="<<Q2<<", nu="<<we<<", mx="
+        G4cout<<"*G4QCollision::PostStDoIt: cost="<<cost<<", Q2="<<Q2<<", nu="<<we<<", mx="
               <<mx<<", pot="<<pot<<", 2KE="<<dKinE<<G4endl;
 #endif
@@ -1077,5 +1082,5 @@
       proj4M-=scat4M;                           // 4mom of the W/Z (effective pion/gamma)
 #ifdef debug
-  		  G4cout<<"G4QCollision::PostStDoIt: proj4M="<<proj4M<<", ml="<<ml<<G4endl;
+      G4cout<<"G4QCollision::PostStDoIt: proj4M="<<proj4M<<", ml="<<ml<<G4endl;
 #endif
       // Check that the en/mom transfer is possible, if not -> elastic
@@ -1162,38 +1167,57 @@
       }
     }
-
   //
-  // quasi-elastic for p+A(Z,N)
+  // quasi-elastic (& pickup process) for p+A(Z,N)
   //
-  } else if (aProjPDG == 2212 && Z > 0 && N > 0) {
-    //else if(2>3)
-
+  }
+  else if (aProjPDG == 2212 && Z > 0 && N > 0)
+  //else if(2>3) 
+  {
     G4QuasiFreeRatios* qfMan=G4QuasiFreeRatios::GetPointer();
     std::pair<G4double,G4double> fief=qfMan->GetRatios(momentum, aProjPDG, Z, N);
     G4double qepart=fief.first*fief.second;
-#ifdef qedebug
-    G4cout<<"G4QCol::PSD:QE[p("<<proj4M<<")+(Z="<<Z<<",N="<<N<<",)="<<qepart<<G4endl;
-#endif
-    if(G4UniformRand()<qepart) // Make a quasi free scattering (out:A-1,h,N) @@ KinLim
-    {
-      // First decay a nucleus in a nucleon and a residual (A-1) nucleus
-      G4double dmom=91.; // Fermi momentum (proto default for a deuteron)
-      if(Z>1||N>1) dmom=286.2*std::pow(-std::log(G4UniformRand()),third);// p_max=250 MeV/c
-
+    // Keep QE part for the quasi-free nucleons
+    const G4int lCl=3; // The last clProb[lCl]==1. by definition, MUST be increasing
+    G4double clProb[lCl]={.65,.85,.95};// N/P,D,t/He3,He4, integratedProb for .65,.2,.1,.05
+    if(qepart>0.45) qepart=.45; // Quasielastic part is too large - shrink
+    else qepart/=clProb[0];     // Add corresponding number of 2N, 3N, & 4N clusters
+    G4double pickup=1.-qepart;  // Estimate the rest of the cross-section
+    G4double thresh=100.;
+    if(momentum > thresh) pickup*=50./momentum/std::pow(Z+N,third); // 50. is a par(!)
+    // pickup = 0.;               // To exclude the pickup process
+    if (N) pickup+=qepart;
+    else   pickup =qepart;
+    G4double rnd=G4UniformRand();
+#ifdef ldebug
+    G4cout<<"-->G4QCol::PSD:QE[p("<<proj4M<<")+(Z="<<Z<<",N="<<N<<")]="<<qepart
+          <<", pickup="<<pickup<<G4endl;
+#endif
+    if(rnd<pickup) // Make a quasi free scattering (out:A-1,h,N) @@ KinLim,CoulBar,PauliBl
+    {
+     G4double dmom=91.;  // Fermi momentum (proto default for a deuteron)
+     G4double fmm=287.;  // @@ Can be A-dependent
+     if(Z>1||N>1) dmom=fmm*std::pow(-std::log(G4UniformRand()),third);
+     // Values to be redefined for quasi-elastic
+     G4LorentzVector r4M(0.,0.,0.,0.);      // Prototype of 4mom of the residual nucleus
+     G4LorentzVector n4M(0.,0.,0.,0.);      // Prototype of 4mom of the quasi-cluster
+     G4int nPDG=90000001;                   // Prototype for quasi-cluster mass calculation
+     G4int restPDG=targPDG;                 // Prototype should be reduced by quasi-cluster
+     G4int rA=Z+N-1;                        // Prototype for the residualNucl definition
+     G4int rZ=Z;                            // residZ: OK for the quasi-free neutron
+     G4int nA=1;                            // Prototype for the quasi-cluster definition
+     G4int nZ=0;                            // nA=1,nZ=0: OK for the quasi-free neutron
+     G4double qM=mNeut;                     // Free mass of the quasi-free cluster
+     G4int A = Z + N;                       // Baryon number of the nucleus
+     if(rnd<qepart)
+     {
+      // ===> First decay a nucleus in a nucleon and a residual (A-1) nucleus
       // Calculate cluster probabilities (n,p,d,t,he3,he4 now only, can use UpdateClusters)
-      const G4int lCl=3; // The last clProb[lCl]==1. by definition, MUST be increasing
-      G4double clProb[lCl]={0.6,0.7,0.8}; // N/P,D,t/He3,Alpha, integrated prob for .6,.1,.1,.2
       G4double base=1.;  // Base for randomization (can be reduced by totZ & totN)
-      G4int max=lCl;   // Number of boundaries (can be reduced by totZ & totN)
-
+      G4int max=lCl;     // Number of boundaries (can be reduced by totZ & totN)
       // Take into account that at least one nucleon must be left !
-      // Change max-- to --max - DHW 05/08
-      G4int A = Z + N;       // Baryon number of the nucleus
       if (Z<2 || N<2 || A<5) base = clProb[--max]; // Alpha cluster is impossible
       if ( (Z > 1 && N < 2) || (Z < 2 && N > 1) ) 
         base=(clProb[max]+clProb[max-1])/2; // t or He3 is impossible
-
-      if ( (Z < 2 && N < 2) || A < 4) base=clProb[--max]; // Both He3 and t clusters are impossible
-
+      if ( (Z < 2 && N < 2) || A < 4) base=clProb[--max];// He3 & t clusters are impossible
       if(A<3)           base=clProb[--max]; // Deuteron cluster is impossible
       G4int cln=0;                          // Cluster#0 (Default for the selected nucleon)
@@ -1207,14 +1231,4 @@
       G4ParticleDefinition* theDefinition;  // Prototype for qfNucleon
       G4bool cp1 = cln+2==A;                // A=ClusterBN+1 condition
-      // Values to be defined in the following IF/ELSE
-      G4LorentzVector r4M(0.,0.,0.,0.);     // Prototype of 4mom of the residual nucleus
-      G4LorentzVector n4M(0.,0.,0.,0.);     // Prototype of 4mom of the quasi-cluster
-      G4int nPDG=90000001;                  // Prototype for quasi-cluster mass calculation
-      G4int restPDG=targPDG;                // Prototype should be reduced by quasi-cluster
-      G4int rA=Z+N-1;                       // Prototype for the residualNucl definition
-      G4int rZ=Z;                           // residZ: OK for the quasi-free neutron
-      G4int nA=1;                           // Prototype for the quasi-cluster definition
-      G4int nZ=0;                           // nA=1,nZ=0: OK for the quasi-free neutron
-      G4double qM=mNeut;                    // Free mass of the quasi-free cluster
       if(!cln || cp1)                       // Split in nucleon + (A-1) with Fermi momentum
       {
@@ -1239,5 +1253,5 @@
         n4M=G4LorentzVector(0.,0.,0.,nM);         // 4mom of the quasi-nucleon
 #ifdef qedebug
-		      G4cout<<"G4QCollis::PStDoIt:QE,p="<<dmom<<",tM="<<tM<<",R="<<rM<<",N="<<nM<<G4endl;
+        G4cout<<"G4QCollis::PStDoIt:QE,p="<<dmom<<",tM="<<tM<<",R="<<rM<<",N="<<nM<<G4endl;
 #endif
         if(!G4QHadron(t4M).DecayIn2(r4M, n4M))
@@ -1247,5 +1261,5 @@
         }
 #ifdef qedebug
-		      G4cout<<"G4QCol::PStDoIt:QE-N,RA="<<r4M.rho()<<r4M<<",QN="<<n4M.rho()<<n4M<<G4endl;
+        G4cout<<"G4QCol::PStDoIt:QE-N,RA="<<r4M.rho()<<r4M<<",QN="<<n4M.rho()<<n4M<<G4endl;
 #endif
         if(cp1 && cln)                           // Quasi-cluster case: swap the output
@@ -1266,5 +1280,5 @@
         }
       }
-      else // Split a cluster (w or w/o "Fermi motion" and "Fermi decay")
+      else // Split the cluster (with or w/o "Fermi motion" and "Fermi decay")
       {
         if(cln==1)
@@ -1275,9 +1289,13 @@
           nZ=1;
           restPDG-=1001;
+          // Recalculate dmom
+          G4ThreeVector sumv=G4ThreeVector(0.,0.,dmom) +
+                      fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+          dmom=sumv.mag();
         }
         else if(cln==2)
         {
           nA=3;
-										if(G4UniformRand()*(A-2)>(N-1)) // He3
+          if(G4UniformRand()*(A-2)>(N-1)) // He3
           {
             nPDG=90002001;
@@ -1293,4 +1311,9 @@
             restPDG-=1002;
           }
+          // Recalculate dmom
+          G4ThreeVector sumv=G4ThreeVector(0.,0.,dmom) +
+                        fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection()+
+                        fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+          dmom=sumv.mag();
         }
         else
@@ -1301,4 +1324,9 @@
           nZ=2;
           restPDG-=2002;
+          G4ThreeVector sumv=G4ThreeVector(0.,0.,dmom) +
+                        fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection()+
+                        fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection()+
+                        fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+          dmom=sumv.mag();
         }
         rA=A-nA;
@@ -1317,5 +1345,5 @@
         n4M=G4LorentzVector(0.,0.,0.,nM);         // 4mom of the quasi-nucleon
 #ifdef qedebug
-		      G4cout<<"G4QCollis::PStDoIt:QEC,p="<<dmom<<",T="<<tM<<",R="<<rM<<",N="<<nM<<G4endl;
+        G4cout<<"G4QCollis::PStDoIt:QEC,p="<<dmom<<",T="<<tM<<",R="<<rM<<",N="<<nM<<G4endl;
 #endif
         if(!G4QHadron(t4M).DecayIn2(r4M, n4M))
@@ -1326,9 +1354,9 @@
         // --- End of the moving cluster implementation ---
 #ifdef qedebug
-		      G4cout<<"G4QCol::PStDoIt:QEC,RN="<<r4M.rho()<<r4M<<",QCl="<<n4M.rho()<<n4M<<G4endl;
+        G4cout<<"G4QCol::PStDoIt:QEC,RN="<<r4M.rho()<<r4M<<",QCl="<<n4M.rho()<<n4M<<G4endl;
 #endif
       }
       G4LorentzVector s4M=n4M+proj4M;             // Tot 4-momentum for scattering
-      G4double prjM2 = proj4M.m2();
+      G4double prjM2 = proj4M.m2();               // Squared mass of the projectile
       G4double prjM = std::sqrt(prjM2);           // @@ Get from pPDG (?)
       G4double minM = prjM+qM;                    // Min mass sum for the final products
@@ -1337,14 +1365,15 @@
       {
 #ifdef qedebug
-		      G4cout<<"G4QCol::PStDoIt:***Enter***,cmM2="<<cmM2<<" > minM2="<<minM*minM<<G4endl;
+        G4cout<<"G4QCol::PStDoIt:***Enter***,cmM2="<<cmM2<<" > minM2="<<minM*minM<<G4endl;
 #endif
         // Estimate and randomize charge-exchange with quasi-free cluster
         G4bool chex=false;                        // Flag of the charge exchange scattering
         G4ParticleDefinition* projpt=G4Proton::Proton(); // Prototype, only for chex=true
+        // This is reserved for the charge-exchange scattering (to help neutron spectras)
         //if(cln&&!cp1 &&(projPDG==2212&&rA>rZ || projPDG==2112&&rZ>1))// @@ Use proj chex
-	       if(2>3)
+        if(2>3)
         {
 #ifdef qedebug
-		        G4cout<<"G4QCol::PStDoIt:-Enter,P="<<projPDG<<",cln="<<cln<<",cp1="<<cp1<<G4endl;
+          G4cout<<"G4QCol::PStDoIt:-Enter,P="<<projPDG<<",cln="<<cln<<",cp1="<<cp1<<G4endl;
 #endif
           G4double tprM=mProt;
@@ -1365,5 +1394,5 @@
           G4double chl=qfMan->ChExElCoef(efP*MeV, nZ, nA-nZ, projPDG); // ChEx/Elast(pPDG!)
 #ifdef qedebug
-		        G4cout<<"G4QCol::PStDoIt:chl="<<chl<<",P="<<efP<<",nZ="<<nZ<<",nA="<<nA<<G4endl;
+          G4cout<<"G4QCol::PStDoIt:chl="<<chl<<",P="<<efP<<",nZ="<<nZ<<",nA="<<nA<<G4endl;
 #endif
           if(chl>0.&&cmM2>minM*minM&&G4UniformRand()<chl/(1.+chl))     // minM is redefined
@@ -1381,5 +1410,5 @@
                                                                          projPDG, proj4M);
 #ifdef qedebug
-		      G4cout<<"G4QCollis::PStDoIt:QElS,proj="<<prjM<<sctout.second<<",qfCl="<<qM
+        G4cout<<"G4QCollis::PStDoIt:QElS,proj="<<prjM<<sctout.second<<",qfCl="<<qM
               <<sctout.first<<",chex="<<chex<<",nA="<<nA<<",nZ="<<nZ<<G4endl;
 #endif
